#############################
## Chapter 4. Documenting Your Work
### How not to forget what you were doing  

# Open a new R script file. Copy the following into it:
#-------------------------------------
#'## A test of document compilation
#' Some important text describing what this data is about. Since this line begins with a "#'" it will be rendered as text
# This is a comment. Since it only begins with a "#" it will be rendered as a comment.
# The code below will be evaluated and the output added to the file.
a<-1:25
b<-sort(rnorm(25)) # by default mean=0 and sd=1
mean(b)
sd(b)
#' Note mean and sd match the default values of sd=1 and mean=0
plot(a,b,type="l",col="red",lwd=2)
#' Figures are included. No need to copy and paste!
#-------------------------------------

# install.packages(rmakrdown") # if not installed
library(rmarkdown) # load the package

rmarkdown::render("Ch4Demo1.R") # compile your document to Rmd
 # error b/c file not in current working directory
rmarkdown::render("code files/Ch4Demo1.R") # compile your document to Rmd


rm(a)

`
Error in plot(a, b, type = "l", col = "red", lwd = 2) : 
  object 'a' not found

`
Quitting from lines 3-12 (Ch4Demo1.spin.Rmd) 
Error in xy.coords(x, y, xlabel, ylabel, log) : 
  'x' and 'y' lengths differ
Calls: <Anonymous> ... withVisible -> eval -> eval -> plot -> plot.default -> xy.coords
Execution halted

spin("Ch4Demo1.R")

###### VI. Exercises. ######

## 1)## Take your code for Ch2 (Problem 4) and Ch3 (Problem 2) and paste it into a single .R file. Test it to make sure it runs. Add comments where needed in the file to discuss/describe the results. Run the code from the console to check it (select all and Ctrl+enter). Now compile the file. (Hint: Before testing the code clear your workspace (Session>Clear Workspace) to be sure the code doesn’t rely on anything left in your workspace from before.)

